function env = adsr (len, attack, decay, sustain, release);
# adsr    Generate an Attack/Decay/Sustain/Release envelope.
#
#
#           env = adsr (samples, attack, decay, sustain, release);

#      Erik de Castro Lopo    9-1-2002

if nargin != 5,
    error ('Insufficient input arguments.') 
    endif
	
if (sustain < 0 || sustain > 1)
	error ('Sustain should be in the range [0..1].')
	endif

if (attack + release + decay >= len)
	error ('Error attack + release + decay >= len.')
	endif

env = [linspace(0,1,attack) linspace(1,sustain,decay) sustain*ones(1,len-attack-decay-release) linspace(sustain,0,release)] ;


endfunction
