function audio_play (sample_rate, data)
#   sndfile_play (sample_rate, data) :
#		Play a sound file using the program sfplay from the libsndfile 
#		distribution.

#   Erik de Castro Lopo  03-01-2002

if (nargin != 2)
		error('sndfile_play needs two arguments!');
endif

[rows, cols] = size (data) ;
if (min ([rows, cols])) > 1,
	error ('sndfile_play can only handle one channels.')
	endif

# Make the data a column vector.
if (rows < cols),
	data = data ' ;
	[rows, cols] = size (data) ;
	endif

# Scale the output to 32 bit integer samples
data = fix (0x7FFFFFFF * data / max (abs (data))) ;

temp_file_name = tmpnam () ;

file = fopen (temp_file_name, 'w') ;
if (file < 0),
	error ('Could not open temp file.')
	endif
fwrite (file, data, 'int') ;
fclose (file) ; 

command = sprintf ("raw_audio_play -%d:32:%d %s", fix (sample_rate), fix (cols), temp_file_name) ;
retval = 0 ;
system (command, retval) ;

unlink (temp_file_name) ;

endfunction;
